/*
 *  MTLLoaders.h
 *  OBJ_MODEL_LOADER_TEST
 *
 *  Created by Christos Sotiriou on 8/19/08.
 *  Copyright 2008 Tei of Pireus. All rights reserved.
 *
 */
#ifndef MTLLOADERS_H
#define MTLLOADERS_H

#include <OpenGL/OpenGL.h>
#include <OpenGL/glu.h>
#include <iostream>
#include <string>

using namespace std;


class MTLMaterial{
public:
	string name;                   /* name of material */
	float diffuse[4];           /* diffuse component */
	float ambient[4];           /* ambient component */
	float specular[4];          /* specular component */
	float emmissive[4];         /* emmissive component */
	float shininess;            /* specular exponent */
	//this is for textures
	GLuint IDTextura;		// ID-ul texturii difuze
	
	MTLMaterial();
	MTLMaterial (const MTLMaterial &other);
	
	MTLMaterial& operator=(const MTLMaterial &other);
	
	void revertToDefault();
	
void showInfo();
};






#endif