/*
 *  MTLLoaders.cpp
 *  OBJ_MODEL_LOADER_TEST
 *
 *  Created by Christos Sotiriou on 8/19/08.
 *  Copyright 2008 Tei of Pireus. All rights reserved.
 *
 */

#include "MTLLoaders.h"

MTLMaterial::MTLMaterial(){
	revertToDefault();
}

MTLMaterial::MTLMaterial (const MTLMaterial &other){
	for (int i=0; i<4; i++) {
		diffuse[i] = other.diffuse[i];
		ambient[i] = other.ambient[i];
		specular[i] = other.specular[i];
		emmissive[i] = other.emmissive[i];
	}
	name = other.name;
	shininess = other.shininess;
	IDTextura = other.IDTextura;
}

MTLMaterial& MTLMaterial::operator=(const MTLMaterial &other){
	for (int i=0; i<4; i++) {
		diffuse[i] = other.diffuse[i];
		ambient[i] = other.ambient[i];
		specular[i] = other.specular[i];
		emmissive[i] = other.emmissive[i];
	}
	name = other.name;
	shininess = other.shininess;
	IDTextura = other.IDTextura;
	return *this;
}

void MTLMaterial::revertToDefault(){
	//name = "untitled SF Material";
	shininess = 65.0;
	diffuse[0] = 0.2;
	diffuse[1] = 0.2;
	diffuse[2] = 0.2;
	diffuse[3] = 1.0;
	ambient[0] = 0.1;
	ambient[1] = 0.1;
	ambient[2] = 0.1;
	ambient[3] = 1.0;
	specular[0] = 0.0;
	specular[1] = 0.0;
	specular[2] = 0.0;
	specular[3] = 1.0;
	IDTextura = -1;
}

void MTLMaterial::showInfo(){
	cout << "name: " << name << '\n';
	cout << "Diffuse: " << diffuse[0] << ',' << diffuse[1] << ',' << diffuse[2] << ',' << diffuse[3] << '\n';
	cout << "ambient: " << ambient[0] << ',' << ambient[1] << ',' << ambient[2] << ',' << ambient[3] << '\n';
	cout << "specular: " << specular[0] << ',' << specular[1] << ',' << specular[2] << ',' << specular[3] << '\n';
	cout << "emmissive: " << emmissive[0] << ',' << emmissive[1] << ',' << emmissive[2] << ',' << emmissive[3] << '\n';
}