#import <Cocoa/Cocoa.h>
#import "ObjLoaders.h"
#include <iostream>
#include "General.h"
#include <GLUT/GLUT.h>
using namespace std;



#define FILENAME @"lightcycle-low.obj"
#define FILENAME2 @"lightcycle-low.txt"
#define FILENAME3 @"Cube.obj"


#define FILENAME6 @"Bau2.obj"
#define FILENAME7 @"Cube.obj"

#define HIGH_LIGHTCYCLE @"objects/Lightcycle-high.obj"
#define CONE_OBJ @"Cone.obj"
#define HIGH_LIGHTCYCLE_WITHOUT_TEXTURE @"test/lightcycle-high.obj"
#define CUBE_OBJ_WITH_TEXTURES @"test/Cube.obj"

#define UPDATE_SECONDS 1.0f/200
#define STANDARD_ROTATION_DEGREES_PREDEFINED_VALUE 0.3f
#define STEP_SIZE 1.0f


@interface MyOpenGLView : NSOpenGLView {
	float xTest;
	float stepSize;
	
	NSPoint lastMousePoint;
	
	float yRot;
	float xRot;
	float standardRotationDegrees;
	
	float upAndDownTranslation;
	float leftAndRightTranslation;
	float nearAndFarTrasnlation;
	NSTimer *timer;
	
	IBOutlet NSTextField *stepSizeTextField;
	IBOutlet NSColorWell *backgroundColorWell;
	IBOutlet NSTextField *modelFileLocationTextField;
	
}

- (IBAction)stopDefaultRotation:(id)sender;
- (void)rotate:(float)degrees;
- (void)loadModelAtLocation:(NSString *)location;
- (void)resetModelPosition;

- (IBAction)rotateUp:(id)sender;
- (IBAction)rotateDown:(id)sender;
- (IBAction)rotateLeft:(id)sender;
- (IBAction)rotateRight:(id)sender;
- (IBAction)moveCameraLeft:(id)sender;
- (IBAction)moveCameraRight:(id)sender;
- (IBAction)moveCameraUp:(id)sender;
- (IBAction)moveCameraDown:(id)sender;
- (IBAction)moveCameraForward:(id)sender;
- (IBAction)moveCameraBackwards:(id)sender;

- (IBAction)comboBoxSelectionDidChange:(id)sender;
- (IBAction)resetModelPosition:(id)sender;
- (IBAction)loadOBJFile:(id)sender;
- (IBAction)toggleTextures:(id)sender;
- (IBAction)toggleLighting:(id)sender;
@end
