/*
 *  TextureLoaders.cpp
 *  Cocoaki3
 *
 *  Created by Christos Sotiriou on 9/21/08.
 *  Copyright 2008 Tei of Pireus. All rights reserved.
 *
 */

#include "TextureLoaders.h"

void BitmapTexture::loadImage(NSString* imagePath){
	NSImage *image = [[NSImage alloc] initWithContentsOfFile:imagePath];
	NSBitmapImageRep *bitmap = [NSBitmapImageRep imageRepWithData:[image TIFFRepresentation]];
	if (bitmap == nil){
		NSLog([@"LoadGLTextures : could not load " stringByAppendingString:imagePath]);
		return;
	}
	glGenTextures(1, &texID);
	glBindTexture(GL_TEXTURE_2D, texID);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR_MIPMAP_NEAREST);
	this->height = [bitmap size].height;
	this->width = [bitmap size].width;
	gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGBA8, [bitmap size].width, [bitmap size].height, [bitmap hasAlpha] ? GL_RGBA : GL_RGB, GL_UNSIGNED_BYTE, [bitmap bitmapData]);
	[image release];
}

BitmapTexture::~BitmapTexture(){
	//glDeleteTextures(1, &this->texID);
}