#ifndef TGALOADERS_H
#define TGALOADERS_H

#include <OpenGL/OpenGL.h>
#include <OpenGL/glu.h>
#include <iostream>
#include <cstdio>

using namespace std;

class Texture{
public:
	GLubyte	* imageData;									// Image Data (Up To 32 Bits)
	GLuint	bpp;											// Image Color Depth In Bits Per Pixel
	GLuint	width;											// Image Width
	GLuint	height;											// Image Height
	GLuint	texID;											// Texture ID Used To Select A Texture
	GLuint	type;											// Image Type (GL_RGB, GL_RGBA)
	~Texture(){
		//free(imageData);
		//glDeleteTextures(1, &texID);
	}
};	

typedef struct{
	GLubyte Header[12];									// TGA File Header
}TGAHeader;


typedef struct{
		GLubyte		header[6];								// First 6 Useful Bytes From The Header
		GLuint		bytesPerPixel;							// Holds Number Of Bytes Per Pixel Used In The TGA File
		GLuint		imageSize;								// Used To Store The Image Size When Setting Aside Ram
		GLuint		temp;									// Temporary Variable
		GLuint		type;	
		GLuint		Height;									//Height of Image
		GLuint		Width;									//Width ofImage
		GLuint		Bpp;									// Bits Per Pixel
} TGA;




class TGALoaderCPP {
	bool LoadUncompressedTGA(Texture * texture, const char * filename, FILE * fTGA);
	bool LoadCompressedTGA(Texture * texture, const char * filename, FILE * fTGA);
public:
	TGAHeader tgaheader;									// TGA header
	TGA tga;	// TGA image data
	Texture texture;
	
	bool LoadTGA(const char * filename);
	bool loadBitmap(const char *filename);
	~TGALoaderCPP(){
		//free(texture.imageData);
	}
};
typedef TGALoaderCPP TGATexture;

#endif